/[gentoo-x86]/eclass/haskell-cabal.eclass
Gentoo

Diff of /eclass/haskell-cabal.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.16 Revision 1.25
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/haskell-cabal.eclass,v 1.16 2009/09/09 18:40:11 kolmodin Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/haskell-cabal.eclass,v 1.25 2011/08/22 04:46:32 vapier Exp $
4# 4
5# @ECLASS: haskell-cabal.eclass
6# @MAINTAINER:
7# Haskell herd <haskell@gentoo.org>
8# @AUTHOR:
5# Original authors: Andres Loeh <kosmikus@gentoo.org> 9# Original author: Andres Loeh <kosmikus@gentoo.org>
6# Duncan Coutts <dcoutts@gentoo.org> 10# Original author: Duncan Coutts <dcoutts@gentoo.org>
7# Maintained by: Haskell herd <haskell@gentoo.org> 11# @BLURB: for packages that make use of the Haskell Common Architecture for Building Applications and Libraries (cabal)
8# 12# @DESCRIPTION:
9# This eclass is for packages that make use of the
10# Haskell Common Architecture for Building Applications
11# and Libraries (cabal).
12#
13# Basic instructions: 13# Basic instructions:
14# 14#
15# Before inheriting the eclass, set CABAL_FEATURES to 15# Before inheriting the eclass, set CABAL_FEATURES to
16# reflect the tools and features that the package makes 16# reflect the tools and features that the package makes
17# use of. 17# use of.
18# 18#
19# Currently supported features: 19# Currently supported features:
20# haddock -- for documentation generation 20# haddock -- for documentation generation
21# hscolour -- generation of colourised sources
21# alex -- lexer/scanner generator 22# alex -- lexer/scanner generator
22# happy -- parser generator 23# happy -- parser generator
23# c2hs -- C interface generator 24# c2hs -- C interface generator
24# cpphs -- C preprocessor clone written in Haskell 25# cpphs -- C preprocessor clone written in Haskell
25# profile -- if package supports to build profiling-enabled libraries 26# profile -- if package supports to build profiling-enabled libraries
26# bootstrap -- only used for the cabal package itself 27# bootstrap -- only used for the cabal package itself
27# bin -- the package installs binaries 28# bin -- the package installs binaries
28# lib -- the package installs libraries 29# lib -- the package installs libraries
29# nocabaldep -- don't add dependency on cabal. 30# nocabaldep -- don't add dependency on cabal.
30# only used for packages that _must_ not pull the dependency 31# only used for packages that _must_ not pull the dependency
31# on cabal, but still use this eclass (e.g. haskell-updater). 32# on cabal, but still use this eclass (e.g. haskell-updater).
32# 33#
33# Dependencies on other cabal packages have to be specified 34# Dependencies on other cabal packages have to be specified
34# correctly. 35# correctly.
35# 36#
36# Cabal libraries should usually be SLOTted with "${PV}". 37# Cabal libraries should usually be SLOTted with "${PV}".
43# Special flags to Cabal Configure can now be set by using 44# Special flags to Cabal Configure can now be set by using
44# CABAL_CONFIGURE_FLAGS 45# CABAL_CONFIGURE_FLAGS
45 46
46inherit ghc-package multilib 47inherit ghc-package multilib
47 48
49# @ECLASS-VARIABLE: CABAL_EXTRA_CONFIGURE_FLAGS
50# @DESCRIPTION:
51# User-specified additional parameters passed to 'setup configure'.
52# example: /etc/make.conf: CABAL_EXTRA_CONFIGURE_FLAGS=--enable-shared
53: ${CABAL_EXTRA_CONFIGURE_FLAGS:=}
54
55# @ECLASS-VARIABLE: GHC_BOOTSTRAP_FLAGS
56# @DESCRIPTION:
57# User-specified additional parameters for ghc when building
58# _only_ 'setup' binary bootstrap.
59# example: /etc/make.conf: GHC_BOOTSTRAP_FLAGS=-dynamic to make
60# linking 'setup' faster.
61: ${GHC_BOOTSTRAP_FLAGS:=}
62
63HASKELL_CABAL_EXPF="pkg_setup src_compile src_test src_install"
64
65case "${EAPI:-0}" in
66 2|3|4) HASKELL_CABAL_EXPF+=" src_configure" ;;
67 *) ;;
68esac
69
70EXPORT_FUNCTIONS ${HASKELL_CABAL_EXPF}
48 71
49for feature in ${CABAL_FEATURES}; do 72for feature in ${CABAL_FEATURES}; do
50 case ${feature} in 73 case ${feature} in
51 haddock) CABAL_USE_HADDOCK=yes;; 74 haddock) CABAL_USE_HADDOCK=yes;;
75 hscolour) CABAL_USE_HSCOLOUR=yes;;
52 alex) CABAL_USE_ALEX=yes;; 76 alex) CABAL_USE_ALEX=yes;;
53 happy) CABAL_USE_HAPPY=yes;; 77 happy) CABAL_USE_HAPPY=yes;;
54 c2hs) CABAL_USE_C2HS=yes;; 78 c2hs) CABAL_USE_C2HS=yes;;
55 cpphs) CABAL_USE_CPPHS=yes;; 79 cpphs) CABAL_USE_CPPHS=yes;;
56 profile) CABAL_USE_PROFILE=yes;; 80 profile) CABAL_USE_PROFILE=yes;;
65if [[ -n "${CABAL_USE_HADDOCK}" ]]; then 89if [[ -n "${CABAL_USE_HADDOCK}" ]]; then
66 IUSE="${IUSE} doc" 90 IUSE="${IUSE} doc"
67 DEPEND="${DEPEND} doc? ( dev-haskell/haddock )" 91 DEPEND="${DEPEND} doc? ( dev-haskell/haddock )"
68fi 92fi
69 93
94if [[ -n "${CABAL_USE_HSCOLOUR}" ]]; then
95 IUSE="${IUSE} hscolour"
96 DEPEND="${DEPEND} hscolour? ( dev-haskell/hscolour )"
97fi
98
70if [[ -n "${CABAL_USE_ALEX}" ]]; then 99if [[ -n "${CABAL_USE_ALEX}" ]]; then
71 DEPEND="${DEPEND} dev-haskell/alex" 100 DEPEND="${DEPEND} dev-haskell/alex"
72 cabalconf="${cabalconf} --with-alex=/usr/bin/alex"
73fi 101fi
74 102
75if [[ -n "${CABAL_USE_HAPPY}" ]]; then 103if [[ -n "${CABAL_USE_HAPPY}" ]]; then
76 DEPEND="${DEPEND} dev-haskell/happy" 104 DEPEND="${DEPEND} dev-haskell/happy"
77 cabalconf="${cabalconf} --with-happy=/usr/bin/happy"
78fi 105fi
79 106
80if [[ -n "${CABAL_USE_C2HS}" ]]; then 107if [[ -n "${CABAL_USE_C2HS}" ]]; then
81 DEPEND="${DEPEND} dev-haskell/c2hs" 108 DEPEND="${DEPEND} dev-haskell/c2hs"
82 cabalconf="${cabalconf} --with-c2hs=/usr/bin/c2hs"
83fi 109fi
84 110
85if [[ -n "${CABAL_USE_CPPHS}" ]]; then 111if [[ -n "${CABAL_USE_CPPHS}" ]]; then
86 DEPEND="${DEPEND} dev-haskell/cpphs" 112 DEPEND="${DEPEND} dev-haskell/cpphs"
87 cabalconf="${cabalconf} --with-cpphs=/usr/bin/cpphs"
88fi 113fi
89 114
90if [[ -n "${CABAL_USE_PROFILE}" ]]; then 115if [[ -n "${CABAL_USE_PROFILE}" ]]; then
91 IUSE="${IUSE} profile" 116 IUSE="${IUSE} profile"
92fi 117fi
111 if [[ -z "${_CABAL_VERSION_CACHE}" ]]; then 136 if [[ -z "${_CABAL_VERSION_CACHE}" ]]; then
112 if [[ "${CABAL_BOOTSTRAP}" ]]; then 137 if [[ "${CABAL_BOOTSTRAP}" ]]; then
113 # We're bootstrapping cabal, so the cabal version is the version 138 # We're bootstrapping cabal, so the cabal version is the version
114 # of this package itself. 139 # of this package itself.
115 _CABAL_VERSION_CACHE="${PV}" 140 _CABAL_VERSION_CACHE="${PV}"
141 elif [[ "${CABAL_FROM_GHC}" ]]; then
142 local cabal_package=$(echo "$(ghc-libdir)"/Cabal-*)
143 # /path/to/ghc/Cabal-${VER} -> ${VER}
144 _CABAL_VERSION_CACHE="${cabal_package/*Cabal-/}"
116 else 145 else
117 # We ask portage, not ghc, so that we only pick up 146 # We ask portage, not ghc, so that we only pick up
118 # portage-installed cabal versions. 147 # portage-installed cabal versions.
119 _CABAL_VERSION_CACHE="$(ghc-extractportageversion dev-haskell/cabal)" 148 _CABAL_VERSION_CACHE="$(ghc-extractportageversion dev-haskell/cabal)"
120 fi 149 fi
142 else 171 else
143 # older ghc's don't support package versioning 172 # older ghc's don't support package versioning
144 cabalpackage=Cabal 173 cabalpackage=Cabal
145 fi 174 fi
146 einfo "Using cabal-$(cabal-version)." 175 einfo "Using cabal-$(cabal-version)."
176
177 make_setup() {
147 $(ghc-getghc) -package "${cabalpackage}" --make "${setupmodule}" -o setup \ 178 $(ghc-getghc) -package "${cabalpackage}" --make "${setupmodule}" \
179 ${GHC_BOOTSTRAP_FLAGS} \
180 "$@" \
181 -o setup
182 }
183 if $(ghc-supports-shared-libraries); then
184 # some custom build systems might use external libraries,
185 # for which we don't have shared libs, so keep static fallback
186 make_setup -dynamic "$@" || make_setup "$@" || die "compiling ${setupmodule} failed"
187 else
148 || die "compiling ${setupmodule} failed" 188 make_setup "$@" || die "compiling ${setupmodule} failed"
189 fi
149} 190}
150 191
151cabal-mksetup() { 192cabal-mksetup() {
152 local setupdir 193 local setupdir
153 194
161 202
162 echo 'import Distribution.Simple; main = defaultMainWithHooks defaultUserHooks' \ 203 echo 'import Distribution.Simple; main = defaultMainWithHooks defaultUserHooks' \
163 > $setupdir/Setup.hs 204 > $setupdir/Setup.hs
164} 205}
165 206
207cabal-hscolour() {
208 ./setup hscolour || die "setup hscolour failed"
209}
210
166cabal-haddock() { 211cabal-haddock() {
167 ./setup haddock || die "setup haddock failed" 212 ./setup haddock || die "setup haddock failed"
168} 213}
169 214
215cabal-hscolour-haddock() {
216 # --hyperlink-source implies calling 'setup hscolour'
217 ./setup haddock --hyperlink-source || die "setup haddock failed"
218}
219
170cabal-configure() { 220cabal-configure() {
221 has "${EAPI:-0}" 0 1 2 && ! use prefix && EPREFIX=
222
171 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then 223 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then
172 cabalconf="${cabalconf} --with-haddock=/usr/bin/haddock" 224 cabalconf="${cabalconf} --with-haddock=${EPREFIX}/usr/bin/haddock"
173 fi 225 fi
174 if [[ -n "${CABAL_USE_PROFILE}" ]] && use profile; then 226 if [[ -n "${CABAL_USE_PROFILE}" ]] && use profile; then
175 cabalconf="${cabalconf} --enable-library-profiling" 227 cabalconf="${cabalconf} --enable-library-profiling"
176 fi 228 fi
229 if [[ -n "${CABAL_USE_ALEX}" ]]; then
230 cabalconf="${cabalconf} --with-alex=${EPREFIX}/usr/bin/alex"
231 fi
232
233 if [[ -n "${CABAL_USE_HAPPY}" ]]; then
234 cabalconf="${cabalconf} --with-happy=${EPREFIX}/usr/bin/happy"
235 fi
236
237 if [[ -n "${CABAL_USE_C2HS}" ]]; then
238 cabalconf="${cabalconf} --with-c2hs=${EPREFIX}/usr/bin/c2hs"
239 fi
240 if [[ -n "${CABAL_USE_CPPHS}" ]]; then
241 cabalconf="${cabalconf} --with-cpphs=${EPREFIX}/usr/bin/cpphs"
242 fi
243
177 # Building GHCi libs on ppc64 causes "TOC overflow". 244 # Building GHCi libs on ppc64 causes "TOC overflow".
178 if use ppc64; then 245 if use ppc64; then
179 cabalconf="${cabalconf} --disable-library-for-ghci" 246 cabalconf="${cabalconf} --disable-library-for-ghci"
180 fi 247 fi
181 248
249 # currently cabal does not respect CFLAGS and LDFLAGS on it's own (bug #333217)
250 # so translate LDFLAGS to ghc parameters (without filtering)
251 local flag
252 for flag in $LDFLAGS; do cabalconf="${cabalconf} --ghc-option=-optl$flag"; done
253
254 if version_is_at_least "1.4" "$(cabal-version)"; then
255 # disable executable stripping for the executables, as portage will
256 # strip by itself, and pre-stripping gives a QA warning.
257 # cabal versions previous to 1.4 does not strip executables, and does
258 # not accept the flag.
259 # this fixes numerous bugs, amongst them;
260 # bug #251881, bug #251882, bug #251884, bug #251886, bug #299494
261 cabalconf="${cabalconf} --disable-executable-stripping"
262 fi
263
182 if version_is_at_least "1.2.0" "$(cabal-version)"; then 264 if version_is_at_least "1.2.0" "$(cabal-version)"; then
183 cabalconf="${cabalconf} --docdir=/usr/share/doc/${PF}" 265 cabalconf="${cabalconf} --docdir=${EPREFIX}/usr/share/doc/${PF}"
184 # As of Cabal 1.2, configure is quite quiet. For diagnostic purposes 266 # As of Cabal 1.2, configure is quite quiet. For diagnostic purposes
185 # it's better if the configure chatter is in the build logs: 267 # it's better if the configure chatter is in the build logs:
186 cabalconf="${cabalconf} --verbose" 268 cabalconf="${cabalconf} --verbose"
187 fi 269 fi
188 # Note: with Cabal-1.1.6.x we do not have enough control 270 # Note: with Cabal-1.1.6.x we do not have enough control
189 # to put the docs into the right place. They're currently going 271 # to put the docs into the right place. They're currently going
190 # into /usr/share/${P}/ghc-x.y/doc/ 272 # into /usr/share/${P}/ghc-x.y/doc/
191 # rather than /usr/share/doc/${PF}/ 273 # rather than /usr/share/doc/${PF}/
192 # Because we can only set the datadir, not the docdir. 274 # Because we can only set the datadir, not the docdir.
193 275
276 # We build shared version of our Cabal where ghc ships it's shared
277 # version of it. We will link ./setup as dynamic binary againt Cabal later.
278 [[ ${CATEGORY}/${PN} == "dev-haskell/cabal" ]] && \
279 $(ghc-supports-shared-libraries) && \
280 cabalconf="${cabalconf} --enable-shared"
281
194 ./setup configure \ 282 ./setup configure \
195 --ghc --prefix=/usr \ 283 --ghc --prefix="${EPREFIX}"/usr \
196 --with-compiler="$(ghc-getghc)" \ 284 --with-compiler="$(ghc-getghc)" \
197 --with-hc-pkg="$(ghc-getghcpkg)" \ 285 --with-hc-pkg="$(ghc-getghcpkg)" \
198 --prefix=/usr \ 286 --prefix="${EPREFIX}"/usr \
199 --libdir=/usr/$(get_libdir) \ 287 --libdir="${EPREFIX}"/usr/$(get_libdir) \
200 --libsubdir=${P}/ghc-$(ghc-version) \ 288 --libsubdir=${P}/ghc-$(ghc-version) \
201 --datadir=/usr/share/ \ 289 --datadir="${EPREFIX}"/usr/share/ \
202 --datasubdir=${P}/ghc-$(ghc-version) \ 290 --datasubdir=${P}/ghc-$(ghc-version) \
203 ${cabalconf} \ 291 ${cabalconf} \
204 ${CABAL_CONFIGURE_FLAGS} \ 292 ${CABAL_CONFIGURE_FLAGS} \
293 ${CABAL_EXTRA_CONFIGURE_FLAGS} \
205 "$@" || die "setup configure failed" 294 "$@" || die "setup configure failed"
206} 295}
207 296
208cabal-build() { 297cabal-build() {
209 unset LANG LC_ALL LC_MESSAGES 298 unset LANG LC_ALL LC_MESSAGES
210 ./setup build \ 299 ./setup build \
211 || die "setup build failed" 300 || die "setup build failed"
212} 301}
213 302
214cabal-copy() { 303cabal-copy() {
304 has "${EAPI:-0}" 0 1 2 && ! use prefix && ED=${D}
305
215 ./setup copy \ 306 ./setup copy \
216 --destdir="${D}" \ 307 --destdir="${D}" \
217 || die "setup copy failed" 308 || die "setup copy failed"
218 309
219 # cabal is a bit eager about creating dirs, 310 # cabal is a bit eager about creating dirs,
220 # so remove them if they are empty 311 # so remove them if they are empty
221 rmdir "${D}/usr/bin" 2> /dev/null 312 rmdir "${ED}/usr/bin" 2> /dev/null
222 313
223 # GHC 6.4 has a bug in get/setPermission and Cabal 1.1.1 has 314 # GHC 6.4 has a bug in get/setPermission and Cabal 1.1.1 has
224 # no workaround. 315 # no workaround.
225 # set the +x permission on executables 316 # set the +x permission on executables
226 if [[ -d "${D}/usr/bin" ]] ; then 317 if [[ -d "${ED}/usr/bin" ]] ; then
227 chmod +x "${D}/usr/bin/"* 318 chmod +x "${ED}/usr/bin/"*
228 fi 319 fi
229 # TODO: do we still need this? 320 # TODO: do we still need this?
230} 321}
231 322
232cabal-pkg() { 323cabal-pkg() {
292 if cabal-is-dummy-lib; then 383 if cabal-is-dummy-lib; then
293 einfo "${P} is included in ghc-${CABAL_CORE_LIB_GHC_PV}, nothing to install." 384 einfo "${P} is included in ghc-${CABAL_CORE_LIB_GHC_PV}, nothing to install."
294 fi 385 fi
295} 386}
296 387
388haskell-cabal_src_configure() {
389 if ! cabal-is-dummy-lib; then
390 pushd "${S}" > /dev/null
391
392 cabal-bootstrap
393
394 cabal-configure $ghc_flags "$@"
395
396 popd > /dev/null
397 fi
398}
399
400# exported function: nice alias
401cabal_src_configure() {
402 haskell-cabal_src_configure "$@"
403}
404
297# exported function: cabal-style bootstrap configure and compile 405# exported function: cabal-style bootstrap configure and compile
298cabal_src_compile() { 406cabal_src_compile() {
407 # it's a common mistake when one bumps ebuild to EAPI="2" (and upper)
408 # and forgets to separate src_compile() to src_configure()/src_compile().
409 # Such error leads to default src_configure and we lose all passed flags.
410 if ! has "${EAPI:-0}" 0 1; then
411 local passed_flag
412 for passed_flag in "$@"; do
413 [[ ${passed_flag} == --flags=* ]] && \
414 eqawarn "Cabal option '${passed_flag}' has effect only in src_configure()"
415 done
416 fi
417
299 if ! cabal-is-dummy-lib; then 418 if ! cabal-is-dummy-lib; then
300 cabal-bootstrap 419 has src_configure ${HASKELL_CABAL_EXPF} || haskell-cabal_src_configure "$@"
301 cabal-configure
302 cabal-build 420 cabal-build
303 421
304 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then 422 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then
423 if [[ -n "${CABAL_USE_HSCOLOUR}" ]] && use hscolour; then
424 # hscolour and haddock
425 cabal-hscolour-haddock
426 else
427 # just haddock
305 cabal-haddock 428 cabal-haddock
429 fi
430 else
431 if [[ -n "${CABAL_USE_HSCOLOUR}" ]] && use hscolour; then
432 # just hscolour
433 cabal-hscolour
434 fi
306 fi 435 fi
307 fi 436 fi
308} 437}
309 438
310haskell-cabal_src_compile() { 439haskell-cabal_src_compile() {
440 pushd "${S}" > /dev/null
441
311 cabal_src_compile 442 cabal_src_compile "$@"
443
444 popd > /dev/null
445}
446
447haskell-cabal_src_test() {
448 pushd "${S}" > /dev/null
449
450 if cabal-is-dummy-lib; then
451 einfo ">>> No tests for dummy library: ${CATEGORY}/${PF}"
452 else
453 einfo ">>> Test phase [cabal test]: ${CATEGORY}/${PF}"
454 ./setup test || die "cabal test failed"
455 fi
456
457 popd > /dev/null
312} 458}
313 459
314# exported function: cabal-style copy and register 460# exported function: cabal-style copy and register
315cabal_src_install() { 461cabal_src_install() {
462 has "${EAPI:-0}" 0 1 2 && ! use prefix && EPREFIX=
463
316 if cabal-is-dummy-lib; then 464 if cabal-is-dummy-lib; then
317 # create a dummy local package conf file for the sake of ghc-updater 465 # create a dummy local package conf file for the sake of ghc-updater
318 dodir "$(ghc-confdir)" 466 local ghc_confdir_with_prefix="$(ghc-confdir)"
467 # remove EPREFIX
468 dodir ${ghc_confdir_with_prefix#${EPREFIX}}
319 echo '[]' > "${D}/$(ghc-confdir)/$(ghc-localpkgconf)" 469 echo '[]' > "${D}/$(ghc-confdir)/$(ghc-localpkgconf)"
320 else 470 else
321 cabal-copy 471 cabal-copy
322 cabal-pkg 472 cabal-pkg
323 473
326 dohtml -r dist/doc/html/* 476 dohtml -r dist/doc/html/*
327 fi 477 fi
328 fi 478 fi
329 fi 479 fi
330} 480}
481
331haskell-cabal_src_install() { 482haskell-cabal_src_install() {
483 pushd "${S}" > /dev/null
484
332 cabal_src_install 485 cabal_src_install
333}
334 486
335EXPORT_FUNCTIONS pkg_setup src_compile src_install 487 popd > /dev/null
488}
489
490# ebuild.sh:use_enable() taken as base
491#
492# Usage examples:
493#
494# CABAL_CONFIGURE_FLAGS=$(cabal_flag gui)
495# leads to "--flags=gui" or "--flags=-gui" (useflag 'gui')
496#
497# CABAL_CONFIGURE_FLAGS=$(cabal_flag gtk gui)
498# also leads to "--flags=gui" or " --flags=-gui" (useflag 'gtk')
499#
500cabal_flag() {
501 if [[ -z "$1" ]]; then
502 echo "!!! cabal_flag() called without a parameter." >&2
503 echo "!!! cabal_flag() <USEFLAG> [<cabal_flagname>]" >&2
504 return 1
505 fi
506
507 local UWORD=${2:-$1}
508
509 if use "$1"; then
510 echo "--flags=${UWORD}"
511 else
512 echo "--flags=-${UWORD}"
513 fi
514
515 return 0
516}

Legend:
Removed from v.1.16  
changed lines
  Added in v.1.25

  ViewVC Help
Powered by ViewVC 1.1.20